qlserver 5.5 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198
  1. #!/bin/bash
  2. # Project: Game Server Managers - LinuxGSM
  3. # Author: Daniel Gibbs
  4. # License: MIT License, Copyright (c) 2017 Daniel Gibbs
  5. # Purpose: Quake Live | Server Management Script
  6. # Contributors: https://github.com/GameServerManagers/LinuxGSM/graphs/contributors
  7. # Documentation: https://github.com/GameServerManagers/LinuxGSM/wiki
  8. # Website: https://gameservermanagers.com
  9. # Debugging
  10. if [ -f ".dev-debug" ]; then
  11. exec 5>dev-debug.log
  12. BASH_XTRACEFD="5"
  13. set -x
  14. fi
  15. version="170501"
  16. ##########################
  17. ######## Settings ########
  18. ##########################
  19. #### Server Settings ####
  20. ## Server Start Settings | https://github.com/GameServerManagers/LinuxGSM/wiki/Start-Parameters
  21. arch="x64" # x64 or x86
  22. ## Server Start Command | https://github.com/GameServerManagers/LinuxGSM/wiki/Start-Parameters#additional-parameters
  23. # Edit with care | Install/Config Guide : https://steamcommunity.com/sharedfiles/filedetails/?id=542966946
  24. # Console Commands : http://www.regurge.at/ql/
  25. fn_parms(){
  26. parms="+exec ${servercfg}"
  27. }
  28. #### LinuxGSM Settings ####
  29. ## Notification Alerts
  30. # (on|off)
  31. # Email Alerts | https://github.com/GameServerManagers/LinuxGSM/wiki/Email
  32. emailalert="off"
  33. email="email@example.com"
  34. emailfrom=""
  35. # Pushbullet Alerts | https://github.com/GameServerManagers/LinuxGSM/wiki/Pushbullet
  36. pushbulletalert="off"
  37. pushbullettoken="accesstoken"
  38. channeltag=""
  39. ## Updating | https://github.com/GameServerManagers/LinuxGSM/wiki/Update
  40. updateonstart="off"
  41. ## Backup | https://github.com/GameServerManagers/LinuxGSM/wiki/Backup
  42. maxbackups="4"
  43. maxbackupdays="30"
  44. stoponbackup="on"
  45. ## Logging | https://github.com/GameServerManagers/LinuxGSM/wiki/Logging
  46. consolelogging="on"
  47. logdays="7"
  48. #### LinuxGSM Advanced Settings ####
  49. ## SteamCMD Settings
  50. # Server appid
  51. appid="349090"
  52. # Steam App Branch Select
  53. # Allows to opt into the various Steam app branches. Default branch is "".
  54. # Example: "-beta latest_experimental"
  55. branch=""
  56. ## Github Branch Select
  57. # Allows for the use of different function files
  58. # from a different repo and/or branch.
  59. githubuser="GameServerManagers"
  60. githubrepo="LinuxGSM"
  61. githubbranch="master"
  62. ## LinuxGSM Server Details
  63. # Do not edit
  64. gamename="Quake Live"
  65. engine="idtech3_ql"
  66. ## Service Name | https://github.com/GameServerManagers/LinuxGSM/wiki/Multiple-Servers
  67. servicename="ql-server"
  68. #### Directories ####
  69. # Edit with care
  70. ## Work Directories
  71. rootdir="$(dirname $(readlink -f "${BASH_SOURCE[0]}"))"
  72. selfname="$(basename $(readlink -f "${BASH_SOURCE[0]}"))"
  73. lockselfname=".${servicename}.lock"
  74. lgsmdir="${rootdir}/lgsm"
  75. functionsdir="${lgsmdir}/functions"
  76. libdir="${lgsmdir}/lib"
  77. tmpdir="${lgsmdir}/tmp"
  78. filesdir="${rootdir}/serverfiles"
  79. ## Server Specific Directories
  80. systemdir="${filesdir}"
  81. executabledir="${filesdir}"
  82. executable=$([ "${arch}" == 'x64' ] && echo "./run_server_x64.sh" || echo "./run_server_x86.sh")
  83. servercfg="${servicename}.cfg"
  84. servercfgdefault="server.cfg"
  85. servercfgdir="${filesdir}/baseq3"
  86. servercfgfullpath="${servercfgdir}/${servercfg}"
  87. ## Backup Directory
  88. backupdir="${rootdir}/backups"
  89. ## Logging Directories
  90. gamelogdir="${rootdir}/log/server"
  91. scriptlogdir="${rootdir}/log/script"
  92. consolelogdir="${rootdir}/log/console"
  93. gamelog="${gamelogdir}/${servicename}-game.log"
  94. scriptlog="${scriptlogdir}/${servicename}-script.log"
  95. consolelog="${consolelogdir}/${servicename}-console.log"
  96. emaillog="${scriptlogdir}/${servicename}-email.log"
  97. ## Logs Naming
  98. scriptlogdate="${scriptlogdir}/${servicename}-script-$(date '+%Y-%m-%d-%H:%M:%S').log"
  99. consolelogdate="${consolelogdir}/${servicename}-console-$(date '+%Y-%m-%d-%H:%M:%S').log"
  100. ########################
  101. ######## Script ########
  102. ###### Do not edit #####
  103. ########################
  104. # Fetches core_dl for file downloads
  105. fn_fetch_core_dl(){
  106. github_file_url_dir="lgsm/functions"
  107. github_file_url_name="${functionfile}"
  108. filedir="${functionsdir}"
  109. filename="${github_file_url_name}"
  110. githuburl="https://raw.githubusercontent.com/${githubuser}/${githubrepo}/${githubbranch}/${github_file_url_dir}/${github_file_url_name}"
  111. # If the file is missing, then download
  112. if [ ! -f "${filedir}/${filename}" ]; then
  113. if [ ! -d "${filedir}" ]; then
  114. mkdir -p "${filedir}"
  115. fi
  116. echo -e " fetching ${filename}...\c"
  117. # Check curl exists and use available path
  118. curlpaths="$(command -v curl 2>/dev/null) $(which curl >/dev/null 2>&1) /usr/bin/curl /bin/curl /usr/sbin/curl /sbin/curl)"
  119. for curlcmd in ${curlpaths}
  120. do
  121. if [ -x "${curlcmd}" ]; then
  122. break
  123. fi
  124. done
  125. # If curl exists download file
  126. if [ "$(basename ${curlcmd})" == "curl" ]; then
  127. curlfetch=$(${curlcmd} -s --fail -o "${filedir}/${filename}" "${githuburl}" 2>&1)
  128. if [ $? -ne 0 ]; then
  129. echo -e "\e[0;31mFAIL\e[0m\n"
  130. echo "${curlfetch}"
  131. echo -e "${githuburl}\n"
  132. exit 1
  133. else
  134. echo -e "\e[0;32mOK\e[0m"
  135. fi
  136. else
  137. echo -e "\e[0;31mFAIL\e[0m\n"
  138. echo "Curl is not installed!"
  139. echo -e ""
  140. exit 1
  141. fi
  142. chmod +x "${filedir}/${filename}"
  143. fi
  144. source "${filedir}/${filename}"
  145. }
  146. core_dl.sh(){
  147. # Functions are defined in core_functions.sh.
  148. functionfile="${FUNCNAME}"
  149. fn_fetch_core_dl
  150. }
  151. core_functions.sh(){
  152. # Functions are defined in core_functions.sh.
  153. functionfile="${FUNCNAME}"
  154. fn_fetch_core_dl
  155. }
  156. # Prevent from running this script as root.
  157. if [ "$(whoami)" = "root" ]; then
  158. if [ ! -f "${functionsdir}/core_functions.sh" ]||[ ! -f "${functionsdir}/check_root.sh" ]||[ ! -f "${functionsdir}/core_messages.sh" ]||[ ! -f "${functionsdir}/core_exit.sh" ]; then
  159. echo "[ FAIL ] Do NOT run this script as root!"
  160. exit 1
  161. else
  162. core_functions.sh
  163. check_root.sh
  164. fi
  165. fi
  166. core_dl.sh
  167. core_functions.sh
  168. getopt=$1
  169. core_getopt.sh